(
	/*
	-- automaticaly create the necessary REs:VRayBumpNormals (cam), VRayMatteShadow, VRayDiffuseFilter, pPos (World)
	-- change MC Seed
	-- render img1
	-- change MC seed
	-- render img2
	-- build cmdline string
	-- execute the denoising
	-- open the denoised image / folder
	*/
	
	global altusRoll
	try (destroyDialog AltusRoll) catch ()
	
	fn checkSetVray = 
	(
		if (renderers.current.classID as string == "#(1941615238, 2012806412)") then renderers.current else 
		(
			if (queryBox "Want me to set VRay as your production renderer?") then 
				(
					(renderers.current = (for i in RendererClass.classes where matchPattern (i as string) pattern:"V_Ray_Adv*" do exit with i()) )
					renderers.current
				)
				else messagebox "Don't blame ME if i don't do what you want me to!"
		)
	)
	
	local cr = checkSetVray()
	local fileBaseName = ""
	local filePassOne = ""
	local filePassTwo = ""
	local fileResult = ""
	local reFilePaths = #()
	local frameNum = sliderTime as integer  
	local altusCommandString = ""
	local fileNamesArray=#()
	local filterRadius = 10
	local useGPU = true
	local animationFrames=#()
	local expandedAnimationFrames=#()
	
	-- output of type baseimage.reName.frame[0000].ext

	fn init =
	(
		reFilePaths = #()
		frameNum = sliderTime as integer  
		altusCommandString = ""
		fileNamesArray=#()
	)

	fn gatherAnimationData =
	(
		expandedAnimationFrames=#()
		case rendTimeType of
		(
			1:
			(
				expandedAnimationFrames[1]=sliderTime as integer
			)
			2:
			(
				for i = (animationRange.start as integer) to (animationRange.end as integer) by (rendNThFrame as integer) do
				(
					append expandedAnimationFrames i
				)
			)
			3:
			(
				start=(rendStart.frame as integer)
				end=(rendEnd.frame as integer)
				nth=rendNThFrame as integer
				base=rendFileNumberBase as integer
				for i = start to end by nth do
				(
					append expandedAnimationFrames i
				)
			)
			4:
			(
				animationFrames= filterstring rendPickupFrames ","
				for f=1 to animationFrames.count do
					(
						stringArray=filterstring animationFrames[f] "-"
						if stringArray.count == 1 then
						(
							append expandedAnimationFrames (animationFrames[f] as integer)
						)
						else
						(
							for i=(stringArray[1] as integer) to (stringArray[2] as integer) do
							(
								append expandedAnimationFrames i
							)
						)
					)
			)
		)
		expandedAnimationFrames
	)
	
	fn readSplitSettings =
	(
		oldSplitSettings=#()
	)
	
	fn padToNDigits numDigits inString=
	(
		inString = inString as string --safety net.
		for i = 1 to (numDigits-inString.count) do
		(
			inString="0"+inString
		)
		inString
	)

	fn cleanREs =
		(
			re = maxOps.GetCurRenderElementMgr()
			elemBaseNamesList=#("AltusVrayDiffuseFilter", "AltusVrayMatteShadow", "AltusVrayBumpNormals","AltusVrayPointPosition","AltusVrayCaustics")
			for n = (re.numrenderelements()- 1) to 0 by -1 do
			(
				el = re.getrenderelement n
				for pat in elemBaseNamesList do 
				(
					if matchpattern el.elementname pattern:pat do 
					(
						re.RemoveRenderElement el
					)
				)
			)
		)
		
	fn addREs =
		(
			re=maxOps.GetCurRenderElementMgr() 
			elemList = #( VrayDiffuseFilter, VrayMatteShadow, VrayBumpNormals,VraySamplerInfo,VrayCaustics)
			elemBaseNamesList=#("AltusVrayDiffuseFilter", "AltusVrayMatteShadow", "AltusVrayBumpNormals","AltusVrayPointPosition","AltusVrayCaustics")
			for r=1 to elemList.count do 
			(
				theElement = (elemList[r]) elementName:elemBaseNamesList[r]
				re.AddRenderElement theElement 
			)
		)
	
	fn setBmpOut basePath imgNum =
	(
		cr.output_splitgbuffer=true
		case imgNum of				-- 0 is the base image path, the one visible to the user, 1 and 2 are the passes, used by the script, 3 is the output altus image, to be used forming the dos command string
		(
			0:										--set BASE output (visible to user)
			(
				fileBaseName=basePath
				cr.output_splitfilename=fileBaseName
				tempBmp=bitmap 1 1 hdr:on filename:fileBaseName
				save tempBmp
				cr.output_splitbitmap=tempBmp
				free tempBmp 
				deleteFile fileBaseName
				fileBaseName
			)
			1:								--set PASS output (invisible to user: passes 1 and 2)
			(
				filePassOne=(getFilenamePath basePath)+(getFilenameFile basePath)+"_b"+(imgNum-1) as string+(getFilenametype basePath)
				cr.output_splitfilename=filePassOne
				tempBmp=bitmap 1 1 hdr:on filename:filePassOne
				save tempBmp
				cr.output_splitbitmap=tempBmp
				free tempBmp 
				deleteFile filePassOne
				filePassOne
			)
			2:								--set PASS output (invisible to user: passes 1 and 2)
			(
				filePassTwo =(getFilenamePath basePath)+(getFilenameFile basePath)+"_b"+(imgNum-1) as string+(getFilenametype basePath)
				cr.output_splitfilename=filePassTwo 
				tempBmp=bitmap 1 1 hdr:on filename:filePassTwo 
				save tempBmp
				cr.output_splitbitmap=tempBmp
				free tempBmp 
				deleteFile filePassTwo
				filePassTwo
			)			
			3:
			(
				fileResult=(getFilenamePath basePath)+(getFilenameFile basePath)+"_Altus"+(getFilenametype basePath) 
			)
		)
	)
	
	fn setREfilePaths passNum frameNum=
	(
		-- output of type baseimage.reName.frame[0000].ext
-- 		frameNum = sliderTime as integer  
		elemBaseNamesList=#("RGB_color","AltusVrayDiffuseFilter", "AltusVrayMatteShadow", "AltusVrayBumpNormals","AltusVrayPointPosition","AltusVrayCaustics")
		for el in elemBaseNamesList do
		(
			backSlashString = ((getFilenamePath fileBaseName)+(getFilenameFile fileBaseName)+"_b"+((passNum-1) as string)+"."+el+"."+(padToNDigits 4 (frameNum+rendFileNumberBase))+(getFilenametype fileBaseName))
-- 			fwdSlashString = substituteString backSlashString @"\" @"/"
			append fileNamesArray backSlashString
		)
		fileNamesArray
	)

	fn buildAltusCommandString =
	(
		altusCommandString="altus.exe "																		--main executable file. the path to its folder is in the system path variable.
		altusCommandString+=("-i \"" + (getfilenamefile (setBmpOut fileBaseName 3)) + "\" ")				--Denoised Result file NAME
		altusCommandString+=("-o \"" + (substring (getfilenamePath fileResult) 1 ((getfilenamePath fileResult).count-1)) + "\" ")									--Denoised Result file PATH
		altusCommandString+=("-b \"" + fileNamesArray[1] + "\" ") + ("-b \"" + fileNamesArray[1+6] + "\" ")		--First and Second BEAUTY passes ("RGB Color")
		altusCommandString+=("-a \"" + fileNamesArray[2] + "\" ") + ("-a \"" + fileNamesArray[2+6] + "\" ")		--First and Second ALBEDO passes ("Diffuse Filter")
		altusCommandString+=("-v \"" + fileNamesArray[3] + "\" ") + ("-v \"" + fileNamesArray[3+6] + "\" ")		--First and Second DIRECT LIGHT VISIBILITY passes ("Matte Shadow")
		altusCommandString+=("-n \"" + fileNamesArray[4] + "\" ") + ("-n \"" + fileNamesArray[4+6] + "\" ")		--First and Second NORMAL passes ("Bump Normal")
		altusCommandString+=("-p \"" + fileNamesArray[5] + "\" ") + ("-p \"" + fileNamesArray[5+6] + "\" ")		--First and Second WORLD POSITION passes ("Point Position World")
		altusCommandString+=("-c \"" + fileNamesArray[6] + "\" ") + ("-c \"" + fileNamesArray[6+6] + "\" ")		--First and Second NORMAL passes ("Bump Normal")
		if useGPU do 
		(
			altusCommandString+=("-g ")
		)
		altusCommandString+=("-r " + (filterRadius as string) + " ")
		
		batchOut = (getfilenamePath fileResult) + (getfilenameFile fileResult) + "_AltusProcess.bat"
		theBatch=openFile batchOut mode:"w"
		format (altusCommandString+"\npause") to:theBatch
		close theBatch
		batchOut
	)
	
	
	fn feedTheBeast frameNum =
	(
		init()
		cleanREs()
		addREs()
		slidertime = frameNum 
-- 		frameNum=(padToNDigits 4 frameNum)
		--the user now has no control: we can change output path and MC seed, and render away.
		setBmpOut fileBaseName 1  	--Pass 1 outputs set up
		cr.dmc_randomSeed=0			--assign it
		setREfilePaths 1 frameNum			--fill the name array of render element file paths for pass 1 (will generate the 6 names) and put them into fileNamesArray[1-6]
		render vfb:off							--render the first pass

		setBmpOut fileBaseName 2  	--Pass 2outputs set up		
		cr.dmc_randomSeed=12340			--assign it		s
		setREfilePaths 2 frameNum			--fill the name array of render element file paths for pass 2 (will generate the 6 names) and put them into fileNamesArray[7-12]
		render vfb:off						--render the second pass
		
		setBmpOut fileBaseName 0
		cleanREs()
		
		for f in fileNamesArray do
		(
			if not doesfileexist f then
			(
				exit with messageBox "Oh-oh!\nFiles are missing!"
			)
			else print "pass checks out on disk, ready to go!"
		)
		-- generate the Altus Output and execute it
		vrayShellLaunch (buildAltusCommandString()) 
	)
	
	fn setEdtBox = 
	(
		if cr.output_splitfilename == undefined or cr.output_splitfilename == "" then
		(
			altusRoll.outEdt.text="Please Browse to Set a base filename output"
			fileBaseName=""
			altusRoll.goBtn.enabled=altusRoll.opnBtn.enabled=altusRoll.outEdt.enabled=false
		)
		else
		(
			altusRoll.outEdt.text=cr.output_splitfilename
			fileBaseName=cr.output_splitfilename
			altusRoll.goBtn.enabled=altusRoll.opnBtn.enabled=altusRoll.outEdt.enabled=true
		)
		fileBaseName
	)

	fn fillInfoBox =
	(
		theString=""
		theString+=("")
	)	
	
	rollout altusRoll "Altus Denoiser Sample GUI v. 0.06" width:504 height:184
	(
		GroupBox 'grp1' "Config:" pos:[8,8] width:488 height:68 align:#left 
 
		label 'tmpLbl' "Base filename:" pos:[16,32] width:72 height:16 align:#left 
 
		button 'outBtn' "Browse..." pos:[88,32] width:64 height:16 align:#left 	
 	
		edittext 'outEdt' "" pos:[152,32] width:320 height:16 enabled:false align:#left
		button 'opnBtn' "O" pos:[476,32] width:16 height:16 enabled:false align:#left
		GroupBox 'grp2' "Altus Processing Options" pos:[8,80] width:488 height:48 align:#left
		label 'fltLbl' "Filter Radius:" pos:[16,104] width:64 height:16 align:#left
		spinner 'fltSpn' "" pos:[88,104] width:56 height:16 range:[1,100,10] type:#integer scale:1 align:#left
		checkbox 'gpuChk' "Checkbox" pos:[152,104] width:16 height:16 checked:true align:#left
		label 'gpuLbl' "Use GPU" pos:[168,104] width:48 height:16 align:#left
		
		button 'goBtn' "Render To Altus Denoiser" pos:[8,136] width:488 height:40 enabled:false align:#left
		
		on altusRoll open do
		(
			init()
			setEdtBox()
		)
		on outBtn pressed do
		(
			try 
			(
				fileBaseName=getSaveFileName caption:"Choose the BASE filename for your output:" filename:"*.exr" types:"OpenEXR(*.exr)|*.exr"
				setBmpOut fileBaseName 0
				setEdtBox()
			)
			catch 
			(
				setEdtBox()
			)
		)
		on outEdt entered txt do
		(
			fileBaseName=txt
			setBmpOut fileBaseName 0
			makeDir (getfilenamepath  fileBaseName)
			setEdtBox()
		)
		on opnBtn pressed do
		(
			try 
			(
				makeDir (getfilenamepath  fileBaseName)
				shellLaunch "explorer.exe" (getfilenamepath fileBaseName)
			) 
			catch()
		)
		on fltSpn changed val do
		(
			filterRadius = val
		)
		on gpuChk changed state do
		(
			useGPU=state
		)
		on goBtn pressed do
		(
			gatherAnimationData()
			for i in expandedAnimationFrames do
			(
				feedTheBeast i 
			)
		)
	)
	createDialog altusRoll
)




